﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.5
@EndOfDesignText@
#DesignerProperty: Key: ShowPathEntryKey, 	DisplayName: Show Path Entry,  	FieldType: Boolean, 	DefaultValue: True, 		Description: Show Path Field Entry 
#DesignerProperty: Key: BorderColorKey,    	DisplayName: Pnl Border Color,	FieldType: Color, 		DefaultValue: 0xFFA39F9F, 	Description: Border Color
#DesignerProperty: Key: BackColorKey,    	DisplayName: Back Color, 	  	FieldType: Color, 		DefaultValue: #FFFFFFFF, 	Description: Panel Back Color
#DesignerProperty: Key: BorderWidthKey,    	DisplayName: Border Width, 	  	FieldType: Int,		 	DefaultValue: 1,	 		Description: Border Width
#DesignerProperty: Key: BorderRadiusKey,   	DisplayName: Border Radius,		FieldType: Int, 		DefaultValue: 4,			Description: Border Radius
#DesignerProperty: Key: TextColorKey,    	DisplayName: Text Color, 	  	FieldType: Color, 		DefaultValue: 0xFFFFFFFF, 	Description: Text Color
#DesignerProperty: Key: TextBackColorKey,   DisplayName: Text Back Color, 	FieldType: Color, 		DefaultValue: #FFFFFFFF, 	Description: Text Back Color

#Event: FileSelected (fAttr As FileAttr_t)
#RaisesSynchronousEvents: FileSelected 

#Event: DirSelected (dir As String)
#RaisesSynchronousEvents: DirSelected 


Sub Class_Globals
	Type FileAttr_t(fileName As String, path As String, size As Long, creationDate As Long, LastModifiedTime As Long, LastAccessTime As Long, readOnly As Boolean, _
					system As Boolean, hidden As Boolean, archived As Boolean, FilePermissions As Map, FileNotFound As Char)
	Type FileDateStr_t(creationDate As String, LastModifiedTime As String, LastAccessTime As String)
	
	Private fx As JFX
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Public  mBase As B4XView
	Private xui As XUI 'ignore
	Private parentForm As Object
	Private Toast As clXToastMessage
		
	Public Tag As Object
	Private btnCpypath As B4XView
	Private btnRecent As B4XView
	Private btnFileNameCpy As B4XView
	Private fileNameInitial As String
	Private pathNameInitial As String
	
	Private fAttr As FileAttr_t
	Private fAttrDatesAsStrings As FileDateStr_t
	
	Private fileNameSel As String
	Private pathNameSel As String
	
	Private fileNameUndo As String
	Private pathNameUndo As String
	
	Private btnGetFileName As B4XView
	Private callingForm As Form

	Private textFilename As B4XView
	Private textPath As B4XView
	Private timerDblClick As Timer
	Private timerDblClickFlag As Boolean
	
	Private dataDir As String
	Private dbRecentFilename As String
	Private sqlRecent As SQL
	Private recentOK As Boolean
	
	Public showPathEntry As Boolean
	Public BorderWidth, BorderRadius As Double
	
	Public initPanelHeight As Int

	Private Pane1 As B4XView
	Private btnPathExpose As B4XView
	Private btnGetFolder As B4XView
	
	Private enableFileSelEvent As Boolean
	Private enableDirSelEvent As Boolean
	Private b4xTableRecent As B4XTable
End Sub


'======================================================================================================
Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	fAttr.Initialize
	fAttrDatesAsStrings.Initialize
	
	timerDblClick.Initialize("timerDblClick", 300)
	
	dbRecentFilename = "RecentFilesDB.db"
	
	dataDir = makeDataDirUnderAppDir("Files")
	recentOK = initRecentDatabase(dataDir, dbRecentFilename)
End Sub


'======================================================================================================
'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
	Tag = mBase.Tag
	mBase.Tag = Me

	Toast.Initialize(mBase)
	Toast.SetTMDefaults
	
	mBase.LoadLayout("fileGetLayout.bjl")
	Sleep(0)
	
	showPathEntry = Props.GetDefault("ShowPathEntryKey", True)
	
	initPanelHeight = Pane1.Height
	
	setShowPathEntry(showPathEntry)

	Dim col As Int = xui.PaintOrColorToColor(Props.GetDefault("BorderColorKey", fx.Colors.From32Bit(0xFFA39F9F)))
	Dim borderCol As Paint = fx.Colors.From32bit(col)

	CSSUtils.SetBackgroundColor(Pane1, fx.Colors.From32bit(Props.GetDefault("BackColorPaneKey", 0xFFFFFFFF)))
	CSSUtils.SetBorder(Pane1, _
					   Props.GetDefault("BorderWidthKey", 1.0), _
					   borderCol, _
					   Props.GetDefault("BorderRadius", 2.0))

	' Add keyboard handlers for the text fields
	Dim r As Reflector
	r.Target = textFilename
	r.AddEventFilter("textFilename", "javafx.scene.input.KeyEvent.KEY_RELEASED")
	
	r.Target = textPath
	r.AddEventFilter("textPath", "javafx.scene.input.KeyEvent.KEY_RELEASED")
	
	r.Target = btnRecent
	r.AddEventFilter("btnRecent", "javafx.scene.input.KeyEvent.KEY_RELEASED")

	r.Target = btnGetFileName
	r.AddEventFilter("btnGetFileName", "javafx.scene.input.KeyEvent.KEY_RELEASED")
	
	r.Target = btnGetFolder
	r.AddEventFilter("btnGetFolder", "javafx.scene.input.KeyEvent.KEY_RELEASED")
	
	r.Target = btnCpypath
	r.AddEventFilter("btnCpypath", "javafx.scene.input.KeyEvent.KEY_RELEASED")
	
	r.Target = btnFileNameCpy
	r.AddEventFilter("btnFileNameCpy", "javafx.scene.input.KeyEvent.KEY_RELEASED")

	'If the recent files database is initialized OK then show the recent files button
	btnRecent.Visible = recentOK
	btnRecent.Enabled = recentOK
	
'	toastMsgShow("warn" , "Warning message")
'	Sleep(10000)
'	toastMsgShow("info" , "Information message")
'	Sleep(10000)
'	toastMsgShow("critical" , "Critical message")
'	Sleep(10000)
'	toastMsgShow("xxx" , "Critical message")
End Sub


'======================================================================================================
Public Sub setShowPathEntry(show As Boolean)
	If show Then
		btnCpypath.Visible 		= True
		textPath.Visible	 	= True
		btnGetFolder.Visible	= True
		Pane1.Height			= initPanelHeight
	Else
		btnCpypath.Visible 		= False
		textPath.Visible	 	= False
		btnGetFolder.Visible	= False
		Pane1.Height			= Pane1.Height / 2 + 2
	End If
End Sub


'======================================================================================================
Public Sub makeDataDirUnderAppDir(dirName As String) As String
	'Get the App dir and check If this is the Objects directory - We don't want to put user files in here
	Dim cwd As String = File.DirApp

	Dim matcher1 As Matcher = Regex.Matcher("[^\\]+\\?$",cwd)
	
	Do While matcher1.Find
		If matcher1.Match.ToLowerCase.CompareTo("objects") = 0 Then
			cwd = Regex.Replace("[^\\]+\\?$", File.DirApp, "\Files")
			Exit
		End If
	Loop
	
	'Check if new cwd Exists and create if neccessary
	If File.IsDirectory (cwd,"") = False Then
		File.MakeDir(cwd, "Files")
	End If
	
	Return cwd
End Sub


'======================================================================================================
public Sub setEnableFileEvent(enArg As Boolean)
	enableFileSelEvent = enArg
End Sub


'======================================================================================================
public Sub getEnableFileEvent As Boolean 
	Return enableFileSelEvent
End Sub


'======================================================================================================
public Sub setEnableDirEvent(enArg As Boolean)
	enableDirSelEvent = enArg
End Sub


'======================================================================================================
public Sub getEnableDirEvent As Boolean 
	Return enableDirSelEvent
End Sub

'======================================================================================================
Public Sub getDataPath As String
	Return dataDir
End Sub


'======================================================================================================
Public Sub getUserPath As String
	Return GetSystemProperty("user.dir", dataDir)
End Sub


'======================================================================================================
public Sub InitCallingForm(callForm As Form)
	callingForm 		= callForm
End Sub


'======================================================================================================
public Sub InitPathAndFileName(pathNameInit As String, filenameInit As String, callForm As Form, parentArg As Object)
	callingForm 		= callForm
	fileNameInitial 	= filenameInit
	pathNameInitial 	= pathNameInit
	fileNameSel			= filenameInit
	pathNameSel 		= pathNameInit
	fileNameUndo		= filenameInit
	pathNameUndo 		= pathNameInit
	textFilename.Text 	= fileNameSel
	textPath.Text 	  	= pathNameSel
	parentForm			= parentArg
End Sub


'======================================================================================================
Private Sub Base_Resize (Width As Double, Height As Double)
  
End Sub


'======================================================================================================
private Sub timerDblClick_tick
	timerDblClick.Enabled = False
	timerDblClickFlag = False
End Sub


'======================================================================================================
private Sub btnFileNameCpy_Click
	If timerDblClickFlag = False Then
		timerDblClick.Enabled = True
		timerDblClickFlag = True
		fx.Clipboard.SetString(fileNameSel)
	Else
		timerDblClick.Enabled = False
		timerDblClickFlag = False
		fx.Clipboard.SetString((pathNameSel & "\" & fileNameSel))
	End If
	Log(fx.Clipboard.GetString)
End Sub


'======================================================================================================
private Sub btnCpypath_Click
	If timerDblClickFlag = False Then
	timerDblClick.Enabled = True
		timerDblClickFlag = True
		fx.Clipboard.SetString(pathNameSel)
	Else
		timerDblClick.Enabled = False
		timerDblClickFlag = False
		fx.Clipboard.SetString((pathNameSel & "\" & fileNameSel))
	End If
	Log(fx.Clipboard.GetString)
End Sub


''======================================================================================================
'private Sub getFolder_Click
'	Dim fd As DirectoryChooser
'	fd.Initialize
'	pathNameUndo = pathNameSel
'	fd.InitialDirectory = pathNameSel
'	fd.Title = "Training Dataset"
'	Dim d As String = fd.Show(callingForm)
'	If d <> "" Then
'		pathNameSel		= d
'		textPath.Text 	= pathNameSel
'	
'		If textFilename.Text <> "" Then
'			fileNameSel = textFilename.Text
'			If File.Exists(pathNameSel, fileNameSel) Then
'				addOrUpdateFile(fileNameSel, pathNameSel, (pathNameSel & "\" & fileNameSel), "n", File.Size(pathNameSel, fileNameSel))
'			End If
'		End If
'	End If
'End Sub


'======================================================================================================
private Sub btnGetFileName_Click

	Dim fc As FileChooser
	fc.Initialize
	fileNameUndo = fileNameSel
	fc.InitialDirectory = pathNameSel
	fc.InitialFileName  = fileNameSel	
	
	Dim fw As FileWatcher
	fw.Initialize("")

	AddExtensionFilters4(fc, Array As String("sQLite.db ","sQLite.sqLite", "sQLite.sqLite3", "sQLite.sqLite2"), _
							 Array As String("*.db", "*.sqlite", "*.sqlite3", "*.sqlite2"), _
							 True,"sqLite Database Files", True)
	
	SetSelectedExtensionFilter(fc,"sqLite Database Files")
	
	fc.Title = "Training Dataset Open"
	Dim f As String = fc.ShowOpen(callingForm)

	FileAttributes(f, fAttr)
End Sub


'======================================================================================================
Sub btnGetFolder_Click

	Dim pc As DirectoryChooser
	pc.Initialize
	pathNameUndo = pathNameSel
	pc.InitialDirectory = pathNameSel

	pathNameSel = pc.Show(callingForm)
	textPath.Text = pathNameSel
	
	If enableDirSelEvent And xui.SubExists(mCallBack, mEventName & "_DirSelected", 0) Then
		CallSub2(mCallBack, mEventName & "_DirSelected", pathNameSel)
	End If

End Sub


'======================================================================================================
public Sub FileAttributes(f As String, fAttrArg As FileAttr_t)
	
	Dim fw As FileWatcher
	fw.Initialize("")
	Dim attrMap As Map
	attrMap.Initialize
	Dim textView As TextField

	fAttrArg.creationDate		= -1
	fAttrArg.LastModifiedTime	= -1
	fAttrArg.LastAccessTime		= -1
	fAttrArg.size				= -1
	
	If f <> "" Then
		pathNameSel					= File.GetFileParent(f)
		fileNameSel 				= File.GetName(f)
		textFilename.Text 			= fileNameSel
		textPath.Text 	  			= pathNameSel
		fAttrArg.fileName			= fileNameSel
		fAttrArg.path				= pathNameSel
		fAttrArg.size				= File.Size(pathNameSel, fileNameSel)
		fAttrArg.creationDate		= fw.GetCreationTime(pathNameSel & "\" & fileNameSel)
		fAttrArg.LastModifiedTime	= fw.GetLastModifiedTime(pathNameSel & "\" & fileNameSel)
		fAttrArg.LastAccessTime		= fw.GetLastAccessTime(pathNameSel & "\" & fileNameSel)
		
		attrMap						= fw.CheckArbitraryAttribute(pathNameSel & "\" & fileNameSel, "dos:readonly")
		fAttrArg.readOnly			= attrMap.GetValueAt(0)
		
		attrMap						= fw.CheckArbitraryAttribute(pathNameSel & "\" & fileNameSel, "dos:system")
		fAttrArg.system				= attrMap.GetValueAt(0)

		attrMap						= fw.CheckArbitraryAttribute(pathNameSel & "\" & fileNameSel, "dos:archive")
		fAttrArg.archived			= attrMap.GetValueAt(0)
		
		attrMap						= fw.CheckArbitraryAttribute(pathNameSel & "\" & fileNameSel, "dos:hidden")
		fAttrArg.hidden				= attrMap.GetValueAt(0)
		
		fAttrArg.FileNotFound		= "n"
		
		fileDateStringFromFileAttr(fAttrArg, fAttrDatesAsStrings)
	
		addOrUpdateFile(fAttrArg, fAttrDatesAsStrings)
		
		textView = textFilename
		textView.TooltipText = pathNameSel & "\" & fileNameSel
		
		textView = textPath
		textView.TooltipText = pathNameSel & "\" & fileNameSel
	End If


	
	If enableFileSelEvent And xui.SubExists(mCallBack, mEventName & "_FileSelected", 0) Then
		CallSub2(mCallBack, mEventName & "_FileSelected", fAttrArg)
	End If
End Sub


'======================================================================================================
public Sub fileDateTimeLongToStdDateTimeString(ticks As Long) As String
	DateTime.DateFormat = "yyyy-MM-dd"
	DateTime.TimeFormat = "HH:mm:ss"
	
	Return DateTime.Date(ticks) & " " & DateTime.Time(ticks)
End Sub


'======================================================================================================
public Sub fileDateStringFromFileAttr(fAttrArg As FileAttr_t, fAttrDatesAsStringsArg As FileDateStr_t)
	If fAttrArg.creationDate = -1 Then
		fAttrDatesAsStringsArg.creationDate = ""
	Else
		fAttrDatesAsStringsArg.creationDate 		= fileDateTimeLongToStdDateTimeString(fAttrArg.creationDate)
	End If

	If fAttrArg.LastModifiedTime = -1 Then
		fAttrDatesAsStringsArg.LastModifiedTime = ""
	Else
		fAttrDatesAsStringsArg.LastModifiedTime 	= fileDateTimeLongToStdDateTimeString(fAttrArg.LastModifiedTime)
	End If

	If fAttrArg.LastAccessTime = -1 Then
		fAttrDatesAsStringsArg.LastAccessTime = ""
	Else
		fAttrDatesAsStringsArg.LastAccessTime 	= fileDateTimeLongToStdDateTimeString(fAttrArg.LastAccessTime)
	End If
End Sub


'======================================================================================================
private Sub btnRecent_Filter(EventData As Event)
	Dim jo As JavaObject = EventData
	Dim code As String = jo.RunMethod("getCode", Null)
	Dim EventType As String = jo.RunMethod("getEventType", Null)
	
	Log(code)
	Log(EventType)
	
	If EventType = "KEY_RELEASED" Then
		Select code
			Case "ENTER"
					
			Case "ESCAPE"
				fileNameSel 		= fileNameUndo
				textFilename.Text 	= fileNameUndo
				pathNameSel			= pathNameUndo
				textPath.Text		= pathNameUndo
				
						
			Case "BACK_SPACE"
					
			Case "F12"
						
		End Select
	End If
End Sub


'======================================================================================================
private Sub btnGetFileName_Filter(EventData As Event)
	Dim jo As JavaObject = EventData
	Dim code As String = jo.RunMethod("getCode", Null)
	Dim EventType As String = jo.RunMethod("getEventType", Null)
	
	Log(code)
	Log(EventType)
	
	If EventType = "KEY_RELEASED" Then
		Select code
			Case "ENTER"
					
			Case "ESCAPE"
				fileNameSel 		= fileNameUndo
				textFilename.Text 	= fileNameUndo
				pathNameSel			= pathNameUndo
				textPath.Text		= pathNameUndo
						
			Case "BACK_SPACE"
					
			Case "F12"
						
		End Select
	End If
End Sub


'======================================================================================================
private Sub getFolder_Filter(EventData As Event)
	Dim jo As JavaObject = EventData
	Dim code As String = jo.RunMethod("getCode", Null)
	Dim EventType As String = jo.RunMethod("getEventType", Null)
	
	Log(code)
	Log(EventType)
	
	If EventType = "KEY_RELEASED" Then
		Select code
			Case "ENTER"
					
			Case "ESCAPE"
				fileNameSel 		= fileNameUndo
				textFilename.Text 	= fileNameUndo
				pathNameSel			= pathNameUndo
				textPath.Text		= pathNameUndo
						
			Case "BACK_SPACE"
					
			Case "F12"
						
		End Select
	End If
End Sub


'======================================================================================================
private Sub btnCpypath_Filter(EventData As Event)
	Dim jo As JavaObject = EventData
	Dim code As String = jo.RunMethod("getCode", Null)
	Dim EventType As String = jo.RunMethod("getEventType", Null)
	
	Log(code)
	Log(EventType)
	
	If EventType = "KEY_RELEASED" Then
		Select code
			Case "ENTER"
					
			Case "ESCAPE"
				fileNameSel 		= fileNameUndo
				textFilename.Text 	= fileNameUndo
				pathNameSel			= pathNameUndo
				textPath.Text		= pathNameUndo
						
			Case "BACK_SPACE"
					
			Case "F12"
						
		End Select
	End If
End Sub


'======================================================================================================
private Sub btnFileNameCpy_Filter(EventData As Event)
	Dim jo As JavaObject = EventData
	Dim code As String = jo.RunMethod("getCode", Null)
	Dim EventType As String = jo.RunMethod("getEventType", Null)
	
	Log(code)
	Log(EventType)
	
	If EventType = "KEY_RELEASED" Then
		Select code
			Case "ENTER"
					
			Case "ESCAPE"
				fileNameSel 		= fileNameUndo
				textFilename.Text 	= fileNameUndo
				pathNameSel			= pathNameUndo
				textPath.Text		= pathNameUndo
						
			Case "BACK_SPACE"
					
			Case "F12"
						
		End Select
	End If
End Sub


'======================================================================================================
Private Sub toastMsgShow(msgType As String, msg As String)
	
	Select msgType.ToLowerCase
		Case "warn", "warning"
			Toast.SetTMBackground(0xFF323232, 4, 0xFFFFE302, 4)
			Toast.SetTMTextProp(16, Toast.HPOS_CENTER, Toast.VPOS_CENTER, 0xFFFFE302)
		Case "info", "information"
			Toast.SetTMBackground(0xFF323232, 4, 0xFFFFFFFF, 4)
			Toast.SetTMTextProp(16, Toast.HPOS_CENTER, Toast.VPOS_CENTER, 0xFFFFFFFF)
		Case "crit", "critical"			
			Toast.SetTMBackground(0xFF323232, 4, 0xFFFF1500, 4)
			Toast.SetTMTextProp(16, Toast.HPOS_CENTER, Toast.VPOS_CENTER, 0xFFFF1500)
		Case Else
			msg = "Illegal Message Type" & CRLF & msg 	
	End Select

	Toast.SetTMPosition(Toast.TMPOS_BOTTOM)
	Toast.SetTMDuration(2000, 3000)
	Toast.TMShow(msg, True, True)
End Sub



'======================================================================================================
private Sub btnRecent_Click
	
	If b4xTableRecent.mBase.Visible Then
		b4xTableRecent.mBase.Visible = False
		If btnCpypath.Visible Then
			Pane1.Height = initPanelHeight
		Else
			Pane1.Height = Pane1.Height / 2 + 2
		End If
	Else
		b4xTableRecent.mBase.Visible  = True
		Pane1.Height = 520
	End If
		
End Sub


'======================================================================================================
private Sub textPath_Action
	
End Sub


'======================================================================================================
private Sub textPath_MouseClicked (EventData As MouseEvent)
	
End Sub


'======================================================================================================
private Sub textPath_FocusChanged (HasFocus As Boolean)
	
End Sub


'======================================================================================================
private Sub textFilename_Action
	

End Sub


'======================================================================================================
private Sub textFilename_TextChanged (Old As String, New As String)

End Sub

'======================================================================================================
private Sub textPath_TextChanged (Old As String, New As String)

End Sub


'======================================================================================================
private Sub textFilename_Filter (EventData As Event)
	Dim jo As JavaObject = EventData
	Dim code As String = jo.RunMethod("getCode", Null)
	Dim EventType As String = jo.RunMethod("getEventType", Null)

	Log(code)
	Log(EventType)
	
	If EventType = "KEY_RELEASED" Then
		Select code	
			Case "ENTER"
				fileNameSel = textFilename.Text
				pathNameSel = textPath.Text
	
				If File.Exists(pathNameSel, fileNameSel) Then
					FileAttributes(pathNameSel & "\" & fileNameSel, fAttr)
				Else
					toastMsgShow("warn" , "File not found")
				End If
			
			Case "ESCAPE"
				textFilename.Text = fileNameUndo
				
			Case "BACK_SPACE"
				
			Case "F12"		

				
		End Select
	End If
End Sub


'======================================================================================================
private Sub textPath_Filter(EventData As Event)
	Dim jo As JavaObject = EventData
	Dim code As String = jo.RunMethod("getCode", Null)
	Dim EventType As String = jo.RunMethod("getEventType", Null)
	
	Log(code)
	Log(EventType)
	
	If EventType = "KEY_RELEASED" Then
		Select code
			Case "ENTER"
				pathNameUndo = pathNameSel
				pathNameSel = textPath.Text
		
				If File.IsDirectory(pathNameSel,"") = False Then
					toastMsgShow("warn" , "Directory not found")
				End If
				
				If enableDirSelEvent And xui.SubExists(mCallBack, mEventName & "_DirSelected", 0) Then
					CallSub2(mCallBack, mEventName & "_DirSelected", pathNameSel)
				End If
				
			Case "ESCAPE"
				textFilename.Text = pathNameUndo
				If enableDirSelEvent And xui.SubExists(mCallBack, mEventName & "_DirSelected", 0) Then
					CallSub2(mCallBack, mEventName & "_DirSelected", pathNameSel)
				End If
					
			Case "BACK_SPACE"
				
			Case "F12"
					
		End Select
	End If	
End Sub


'======================================================================================================
private Sub textFilename_MouseClicked (EventData As MouseEvent)
	
End Sub


'======================================================================================================
private Sub textFilename_FocusChanged (HasFocus As Boolean)
	
End Sub


'======================================================================================================
private Sub initRecentDatabase(path As String, dbName As String) As Boolean

	If File.Exists(path, dbName) Then
		Try
			sqlRecent.InitializeSQLite(path, dbName, False)
			'   				  logOn, setJournal, integrityCheck, doFullCheckPoint, setAutoCheckPoint) As Boolean
			If checkRecentFilesDB(True,  "WAL",      True,           True,             -3) = False Then
				Return False
			End If
		Catch
			Log(LastException)
			Return False
		End Try
	Else
		Try
			sqlRecent.InitializeSQLite(path, dbName, True) 
		Catch
			Log(LastException)
			Return False
		End Try
		
		Try
			'Create the recent files table
			createRecentTable

			'   				  logOn, setJournal, integrityCheck, doFullCheckPoint, setAutoCheckPoint) As Boolean
			If checkRecentFilesDB(True,  "WAL",      False,          False, 		   -3) = False Then
				Return False
			End If
		Catch
			Log(LastException)
			Return False
		End Try
	End If
	Return True
End Sub



'======================================================================================================
Public Sub RemoveRedundantSpace(TextToClean As String) As String
	Return Regex.Replace("[\s]{2,}", TextToClean, " ")
End Sub



'======================================================================================================
Public Sub checkRecentFilesDB(logOn As Boolean, setJournal As String, integrityCheck As Boolean, doFullCheckPoint As Boolean, setAutoCheckPoint As Int) As Boolean
	'Check the database
	Dim qryStr As String
	Dim qryOutList As List
	Dim row() As String
	
	If integrityCheck Then
		qryStr = "PRAGMA integrity_check;"
		qryOutList = ExecuteMemoryTable(sqlRecent, qryStr, Null, 2)
		row = qryOutList.Get(0)
		If row(0).CompareTo("ok") <> 0 Then
			If logOn Then Log("DB Integrity = BAD")
			Return False
		End If
	
		If logOn Then Log("DB Integrity = OK")
	End If
	
	
	If setJournal <> "" Then
		qryStr = "PRAGMA journal_mode=" &  setJournal & ";"
		qryOutList = ExecuteMemoryTable(sqlRecent, qryStr, Null, 2)
		row = qryOutList.Get(0)
		If row(0).CompareTo("wal") <> 0 Then
			If logOn Then Log("Set Journal Mode = " &  setJournal & " Mode = FAILED")
			Return False
		End If
		
		If logOn Then Log("Set Journal Mode = " &  setJournal & " Mode = OK")
	End If
	
	
	If doFullCheckPoint Then
		qryStr = "PRAGMA wal_checkpoint(TRUNCATE);"
		Try
			qryOutList = ExecuteMemoryTable(sqlRecent, qryStr, Null, 2)
		Catch
			Log(LastException)
			If logOn Then Log("Checkpoint TRUNCATE = Failed")
			Return False
		End Try

		row = qryOutList.Get(0)
		If row(0) < 0 Then
			If logOn Then Log("Checkpoint TRUNCATE = Failed")
			Return False
		End If

		If logOn Then Log("Checkpoint TRUNCATE = OK:  Busy = " & row(0) & "  Log = " & row(1) & "  Checkpointed = " & row(2))
	End If
	

	If setAutoCheckPoint <> -3 Then
		Select setAutoCheckPoint
			Case -1
				qryStr = "PRAGMA wal_autocheckpoint=-1;" 	'No checkpoint
			Case 0
				qryStr = "PRAGMA wal_autocheckpoint=1000;"  'sqLite Default
			Case Else
				qryStr = "PRAGMA wal_autocheckpoint=" & setAutoCheckPoint & ";" 'User setting
		End Select
			
		qryOutList = ExecuteMemoryTable(sqlRecent, qryStr, Null, 2)
		row = qryOutList.Get(0)
		If row(0) < 0 Then
			If logOn Then Log("DB Checkpoint Value Setting = Failed")
			Return False
		End If
		
		If logOn Then Log("DB Checkpoint Value Setting = OK")
	End If
	Return True
End Sub


'======================================================================================================
'Executes the query and returns the result as a list of arrays.
'Each item in the list is a strings array.
'StringArgs - Values to replace question marks in the query. Pass Null if not needed.
'Limit - Limits the results. Pass 0 for all results.
Public Sub ExecuteMemoryTable(SQL As SQL, Query As String, StringArgs() As String, Limit As Int) As List
	Dim cur As ResultSet
	Dim stringTemp() As String
	
	stringTemp = StringArgs
	If StringArgs = Null Then
		Dim StringArgs(0) As String
	End If
	
	Try
		cur = SQL.ExecQuery2(Query, StringArgs)
	Catch
		Log(LastException)
		Return Null
	End Try
	
'	Log("ExecuteMemoryTable: " & Query)
	Dim table As List
	table.Initialize
	
	Try
		Do While cur.NextRow
			Dim values(cur.ColumnCount) As String
			For col = 0 To cur.ColumnCount - 1
				values(col) = cur.GetString2(col)
			Next
			table.Add(values)
			If Limit > 0 And table.Size >= Limit Then Exit
		Loop
	Catch
		Log(LastException)
		Return Null
	End Try

	cur.Close
	Return table
End Sub


'======================================================================================================
Private Sub createRecentTable
	
	Dim qryStr As String = _
	$"CREATE TABLE tblRecentFiles(
  		ID INTEGER, 
  		fileName TEXT, 
  		path TEXT, 
  		fullPath TEXT, 
  		dateFirstSelected DATETIME, 
  		dateLastSelected DATETIME, 
        dateCreated DATETIME,
        dateLastModified DATETIME,
        dateLastAccessed DATETIME,
  		fileNotFound CHAR, 
  		fileSize LARGEINT, 
		readOnly BOOLEAN,
		hidden BOOLEAN,
		archive  BOOLEAN,
		system BOOLEAN,
  	CONSTRAINT ID PRIMARY KEY(ID COLLATE BINARY))"$
	
	sqlRecent.BeginTransaction
	Try
		sqlRecent.ExecNonQuery(qryStr)
	Catch
		Log(LastException)
		Return
	End Try
	sqlRecent.TransactionSuccessful
End Sub



'======================================================================================================
Private Sub addOrUpdateFile(fat As FileAttr_t, fatD As FileDateStr_t) As Boolean
	'Check if full path exists
	Dim qryStr As String
	Dim dateStr As String
	DateTime.DateFormat = "yyyy-MM-dd" 
	DateTime.TimeFormat = "HH:mm:ss"
	dateStr = DateTime.Date(DateTime.Now) & " " & DateTime.Time(DateTime.Now)
	
	Dim fullPath As String = fat.path & "\" & fat.fileName
	
	qryStr = _
	$"SELECT COUNT(fullPath) FROM tblRecentFiles WHERE fullPath = ?"$
	
	Dim cur As ResultSet
	
'	sqlRecent.BeginTransaction
	Try
		cur = sqlRecent.ExecQuery2(qryStr, Array As String(fullPath))
	Catch
		Log(LastException)
	End Try
'	sqlRecent.TransactionSuccessful
	
	cur.NextRow
	If cur.GetLong2(0) = 0 Then
		qryStr = _
				$"INSERT INTO tblRecentFiles (
                  fileName,
                  path,
				  fullPath,
                  dateFirstSelected,
                  dateLastSelected,
				  dateCreated,
        		  dateLastModified,
        		  dateLastAccessed,
				  fileNotFound,
				  fileSize,
				  readOnly,
				  hidden,
				  archive,
				  system
				  )
                  VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)"$
						  
		qryStr = RemoveRedundantSpace(qryStr)
		
		sqlRecent.BeginTransaction
		Try
			sqlRecent.ExecNonQuery2(qryStr, Array As String(fat.fileName, fat.path, fullPath, _
									dateStr, dateStr, fatD.creationDate, fatD.LastModifiedTime, fatD.LastAccessTime, _
									fat.FileNotFound, fat.size, fat.readOnly, fat.hidden, fat.archived, fat.system))
			
			Log("Recent File Added: " & fullPath &  "  Date: " & dateStr)
		Catch
			Log(LastException)
		End Try
		sqlRecent.TransactionSuccessful
		
	Else
		qryStr = _
				$"UPDATE tblRecentFiles 
					SET 
						dateLastSelected	= ?, 
						dateCreated			= ?, 
        		  		dateLastModified	= ?, 
        		  		dateLastAccessed	= ?, 
				  		fileNotFound		= ?, 
				  		fileSize			= ?, 
				  		readOnly			= ?, 
				  		hidden				= ?, 
				  		archive				= ?, 
				  		system				= ? 
					WHERE fullPath 			= ?"$
	
		qryStr = RemoveRedundantSpace(qryStr)
		
		sqlRecent.BeginTransaction
		Try
			sqlRecent.ExecNonQuery2(qryStr, Array As String(dateStr, fatD.creationDate, fatD.LastModifiedTime, fatD.LastAccessTime, _
									fat.FileNotFound, fat.size, fat.readOnly, fat.hidden, fat.archived, fat.system, fullPath))
			Log("Recent File Updated: " & fullPath &  "  Date: " & dateStr)
		Catch
			Log(LastException)
		End Try
		sqlRecent.TransactionSuccessful
		
	End If
	Return True
End Sub

'======================================================================================================


'************************** Author:  stevel05 *********************************************************
'https://www.b4x.com/android/forum/threads/file-chooser-utils.92092/#content

'Adds the specified file extenstions.
'There must be the same number of Descriptions as Filters.
Public Sub AddExtensionFilters(FC As FileChooser, Descriptions As List, Filters As List)
	AddExtensionFilters4(FC,Descriptions, Filters, False,"", False)
End Sub


'======================================================================================================
'Adds the specified file extenstions and optional merged item.
'There must be the same number of Descriptions as Filters.
Public Sub AddExtensionFilters2(FC As FileChooser, Descriptions As List, Filters As List, MergeName As String)
	AddExtensionFilters4(FC,Descriptions, Filters, True, MergeName, False)
End Sub


'======================================================================================================
'Adds the specified file extenstions and optional AllFIles item.
'There must be the same number of Descriptions as Filters.
Public Sub AddExtensionFilters3(FC As FileChooser, Descriptions As List, Filters As List, AllFiles As Boolean)
	AddExtensionFilters4(FC,Descriptions, Filters, False, "", AllFiles)
End Sub


'======================================================================================================
'Adds the specified file extenstions and optional merged item and optional All Files item.
'There must be the same number of Descriptions as Filters.
Public Sub AddExtensionFilters4(FC As FileChooser, Descriptions As List, Filters As List, Merge As Boolean, MergeName As String, AllFiles As Boolean)
	If Descriptions.Size <> Filters.Size Then
		Log("Extension filters not added")
		Return
	End If
	Dim ExtFilters As List
	ExtFilters.Initialize

	If AllFiles Then
		Dim ExtensionFilter As JavaObject
		ExtensionFilter.InitializeNewInstance("javafx.stage.FileChooser.ExtensionFilter",Array("All Files",Array As String("*.*")))
		ExtFilters.add(ExtensionFilter)
	End If

	If Merge Then
		Dim ExtensionFilter As JavaObject
		ExtensionFilter.InitializeNewInstance("javafx.stage.FileChooser.ExtensionFilter",Array(MergeName,Filters))
		ExtFilters.add(ExtensionFilter)
	End If

	For i = 0 To Filters.Size - 1
		Dim ExtensionFilter As JavaObject
		ExtensionFilter.InitializeNewInstance("javafx.stage.FileChooser.ExtensionFilter",Array(Descriptions.Get(i),Array As String(Filters.Get(i))))
		ExtFilters.add(ExtensionFilter)
	Next
	Dim FCJO As JavaObject = FC
	Dim EFs As List = FCJO.RunMethod("getExtensionFilters",Null)
	EFs.AddAll(ExtFilters)
End Sub


'======================================================================================================
'Pass the Description to specify the initially selected file extension.  
'Pass the MergeName or 'All Files' if you use these options and want either to be preselected
Public Sub SetSelectedExtensionFilter(FC As FileChooser, Description As String)
	Dim FCJO As JavaObject = FC
	Dim EFs As List = FCJO.RunMethod("getExtensionFilters",Null)
	For Each EF As JavaObject In EFs
		If EF.RunMethod("getDescription",Null) = Description Then
			FCJO.RunMethod("setSelectedExtensionFilter",Array(EF))
			Exit
		End If
	Next
End Sub


'======================================================================================================
Sub btnPathExpose_Click
	If btnCpypath.Visible = False Then
		btnCpypath.Visible = True
	Else
		btnCpypath.Visible = False
	End If
	
	setShowPathEntry(btnCpypath.Visible)
End Sub


'======================================================================================================
Sub b4xTableRecent_CellClicked (ColumnId As String, RowId As Long)
	
End Sub


'======================================================================================================
Sub b4xTableRecent_CellLongClicked (ColumnId As String, RowId As Long)
	
End Sub


'======================================================================================================
Sub b4xTableRecent_DataUpdated
	
End Sub


'======================================================================================================
Sub b4xTableRecent_HeaderClicked (ColumnId As String)
	
End Sub


'======================================================================================================
Sub b4xTableRecent_HeaderLongClicked (ColumnId As String)
	
End Sub


